/***
 * Excerpted from "iOS APPs with Rest APIs",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/d-cmrest for more book information.
***/
//
//  PINRemoteLock.h
//  Pods
//
//  Created by Garrett Moon on 3/17/16.
//
//

#import <Foundation/Foundation.h>

/** The type of lock, either recursive or non-recursive */
typedef NS_ENUM(NSUInteger, PINRemoteLockType) {
    /** A non-recursive version of the lock. The default. */
    PINRemoteLockTypeNonRecursive = 0,
    /** A recursive version of the lock. More expensive. */
    PINRemoteLockTypeRecursive,
};

@interface PINRemoteLock : NSObject

- (instancetype)initWithName:(NSString *)lockName lockType:(PINRemoteLockType)lockType NS_DESIGNATED_INITIALIZER;
- (instancetype)initWithName:(NSString *)lockName;
- (void)lockWithBlock:(dispatch_block_t)block;

- (void)lock;
- (void)unlock;

@end
